
public class LinkedList
{
    /**
     * Verweis auf das erste element der liste
     */
    private Node head = null;
    
    /**
     * Verweis auf das letzte element der liste
     */
    private Node tail = null;
    
    /**
     * Vorne in die Liste einfgen.
     * @param node Node
     */
    public void insert(int value)
    {            
        Node node = new Node(value, head, null);   
        
        if (head != null)
        {
            this.head.setPrev(node); 
        }
        
        this.head = node;
        
        if (tail == null)
        {
            this.tail = node;
        }   
    }
    
    /**
     * Hinten an die Liste ranhngen.
     * @param value
     */
    public void append(int value)
    {
        if (head == null)
        {
            this.insert(value);
        }
        else
        {
            Node node = new Node(value, null, tail);  
            
            if (tail != null)
            {
                this.tail.setNext(node); 
            }
            
            this.tail = node;
        }
    }
    

    /**
     * Dreht die Liste um
     */
    public void reverse()
    {
        Node node = head;
        Node temp;
        
        while (node != null)
        {       
           // Tausche die Referenzen 
           temp = node.getNext();
           node.setNext(node.getPrev());
           node.setPrev(temp);
           
           // Setze Node auf das nchste Element
           node = temp;
        }
        
        // Tausche head und tail
        temp = head;
        head = tail;
        tail = temp; 
    }
    
    public void printList()
    {
        Node node = head;
       
        while (node != null)
        {
            System.out.println(node.getValue());
            node = node.getNext();
        }    
    }
    
    public int getLength()
    {       
        Node node = head;
        int result = 0;
        
        while (node != null)
        {
            result++;
            node = node.getNext();
        }
        
        return  result;
    }

    public Node getTail()
    {
        return tail;
    }
    
    public Node getHead()
    {
        return head;
    }    
}
